using System;

namespace ElasticBand
{
	public class Punkt
	{
		private Vector coords;
		private Vector velo;
		//private float velocity;
		//private float direction;

		public Punkt(Vector startPoint, Vector startVelocity)
		{
			this.coords = startPoint;
			this.Velocity = startVelocity;
			//this.velocity = 0;
			//this.direction = 1;
		}

		public void BerechneGrav()
		{
			velo.Y += 0.01f;
		}

		public void BerechneLuft()
		{
			velo.X *= 0.995f;
			velo.Y *= 0.995f;
		}

		public void BerechnePos(float x, float y)
		{
			if(coords.X <= 0 || coords.X >= x)
			{
				velo.X *= -1;
			}
			if(coords.Y <= 0 || coords.Y >= y)
			{
				velo.Y *= -1;
			}

			coords.X += velo.X;
			coords.Y += velo.Y;
		}

		public Vector Coords
		{
			get { return coords; }
			set { coords = value; }
		}

		public Vector Velocity
		{
			get { return velo; }
			set { velo = value; }
		}
	}
}