using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Data;

namespace ElasticBand
{
	/// <summary>
	/// Zusammendfassende Beschreibung fr Form1.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox;
		private System.Windows.Forms.Timer timer;
		private System.Windows.Forms.CheckedListBox listBox;
		private System.Windows.Forms.Button cmdAdd;
		private System.Drawing.SolidBrush brushBlack;
		private System.Drawing.Pen penRed;
		private System.Drawing.Pen penBlack;
		private System.Windows.Forms.TextBox txtXPos;
		private System.Windows.Forms.TextBox txtYPos;
		private System.Windows.Forms.TextBox txtXVel;
		private System.Windows.Forms.TextBox txtYVel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.CheckBox cbLuft;
		private System.Windows.Forms.CheckBox cbGrav;
		private System.Windows.Forms.Button cmdRemove;
		private System.Windows.Forms.ListBox lbJunction;
		private System.ComponentModel.IContainer components;

		public frmMain()
		{
			InitializeComponent();
			
			this.SetStyle(ControlStyles.DoubleBuffer, true);
			this.SetStyle(ControlStyles.UserPaint, true);
			this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);

			brushBlack = new SolidBrush(Color.Black);
			penRed = new Pen(Color.Red);
			penBlack = new Pen(Color.Black);
			penBlack.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pictureBox = new System.Windows.Forms.PictureBox();
			this.timer = new System.Windows.Forms.Timer(this.components);
			this.listBox = new System.Windows.Forms.CheckedListBox();
			this.cmdAdd = new System.Windows.Forms.Button();
			this.txtXPos = new System.Windows.Forms.TextBox();
			this.txtYPos = new System.Windows.Forms.TextBox();
			this.txtXVel = new System.Windows.Forms.TextBox();
			this.txtYVel = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.cbLuft = new System.Windows.Forms.CheckBox();
			this.cbGrav = new System.Windows.Forms.CheckBox();
			this.cmdRemove = new System.Windows.Forms.Button();
			this.lbJunction = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// pictureBox
			// 
			this.pictureBox.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.pictureBox.BackColor = System.Drawing.Color.White;
			this.pictureBox.Name = "pictureBox";
			this.pictureBox.Size = new System.Drawing.Size(464, 568);
			this.pictureBox.TabIndex = 0;
			this.pictureBox.TabStop = false;
			this.pictureBox.Paint += new System.Windows.Forms.PaintEventHandler(this.pictureBox_Paint);
			this.pictureBox.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseDown);
			// 
			// timer
			// 
			this.timer.Enabled = true;
			this.timer.Interval = 5;
			this.timer.Tick += new System.EventHandler(this.timer_Tick);
			// 
			// listBox
			// 
			this.listBox.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.listBox.Location = new System.Drawing.Point(472, 0);
			this.listBox.Name = "listBox";
			this.listBox.Size = new System.Drawing.Size(200, 214);
			this.listBox.TabIndex = 1;
			// 
			// cmdAdd
			// 
			this.cmdAdd.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cmdAdd.Location = new System.Drawing.Point(472, 224);
			this.cmdAdd.Name = "cmdAdd";
			this.cmdAdd.TabIndex = 2;
			this.cmdAdd.Text = "Add";
			this.cmdAdd.Click += new System.EventHandler(this.cmdAdd_Click);
			// 
			// txtXPos
			// 
			this.txtXPos.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.txtXPos.Location = new System.Drawing.Point(536, 256);
			this.txtXPos.Name = "txtXPos";
			this.txtXPos.Size = new System.Drawing.Size(128, 20);
			this.txtXPos.TabIndex = 3;
			this.txtXPos.Text = "";
			// 
			// txtYPos
			// 
			this.txtYPos.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.txtYPos.Location = new System.Drawing.Point(536, 280);
			this.txtYPos.Name = "txtYPos";
			this.txtYPos.Size = new System.Drawing.Size(128, 20);
			this.txtYPos.TabIndex = 4;
			this.txtYPos.Text = "";
			// 
			// txtXVel
			// 
			this.txtXVel.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.txtXVel.Location = new System.Drawing.Point(536, 304);
			this.txtXVel.Name = "txtXVel";
			this.txtXVel.Size = new System.Drawing.Size(128, 20);
			this.txtXVel.TabIndex = 5;
			this.txtXVel.Text = "";
			// 
			// txtYVel
			// 
			this.txtYVel.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.txtYVel.Location = new System.Drawing.Point(536, 328);
			this.txtYVel.Name = "txtYVel";
			this.txtYVel.Size = new System.Drawing.Size(128, 20);
			this.txtYVel.TabIndex = 6;
			this.txtYVel.Text = "";
			// 
			// label1
			// 
			this.label1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.label1.Location = new System.Drawing.Point(472, 256);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 7;
			this.label1.Text = "X-Pos:";
			// 
			// label2
			// 
			this.label2.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.label2.Location = new System.Drawing.Point(472, 280);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 23);
			this.label2.TabIndex = 8;
			this.label2.Text = "Y-Pos:";
			// 
			// label3
			// 
			this.label3.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.label3.Location = new System.Drawing.Point(472, 304);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(64, 23);
			this.label3.TabIndex = 9;
			this.label3.Text = "X-Geschw.:";
			// 
			// label4
			// 
			this.label4.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.label4.Location = new System.Drawing.Point(472, 328);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(64, 23);
			this.label4.TabIndex = 10;
			this.label4.Text = "Y-Geschw.:";
			// 
			// cbLuft
			// 
			this.cbLuft.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cbLuft.Location = new System.Drawing.Point(536, 360);
			this.cbLuft.Name = "cbLuft";
			this.cbLuft.Size = new System.Drawing.Size(128, 24);
			this.cbLuft.TabIndex = 11;
			this.cbLuft.Text = "Luftwiderstand";
			// 
			// cbGrav
			// 
			this.cbGrav.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cbGrav.Location = new System.Drawing.Point(536, 392);
			this.cbGrav.Name = "cbGrav";
			this.cbGrav.Size = new System.Drawing.Size(128, 24);
			this.cbGrav.TabIndex = 12;
			this.cbGrav.Text = "Gravitation";
			// 
			// cmdRemove
			// 
			this.cmdRemove.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.cmdRemove.Location = new System.Drawing.Point(592, 224);
			this.cmdRemove.Name = "cmdRemove";
			this.cmdRemove.TabIndex = 13;
			this.cmdRemove.Text = "Remove";
			this.cmdRemove.Click += new System.EventHandler(this.cmdRemove_Click);
			// 
			// lbJunction
			// 
			this.lbJunction.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.lbJunction.Location = new System.Drawing.Point(472, 432);
			this.lbJunction.Name = "lbJunction";
			this.lbJunction.Size = new System.Drawing.Size(200, 134);
			this.lbJunction.TabIndex = 14;
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(672, 573);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lbJunction,
																		  this.cmdRemove,
																		  this.cbGrav,
																		  this.cbLuft,
																		  this.label4,
																		  this.label3,
																		  this.label2,
																		  this.label1,
																		  this.txtYVel,
																		  this.txtXVel,
																		  this.txtYPos,
																		  this.txtXPos,
																		  this.cmdAdd,
																		  this.listBox,
																		  this.pictureBox});
			this.KeyPreview = true;
			this.Name = "frmMain";
			this.Text = "BitBlt";
			this.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.frmMain_KeyPress);
			this.ResumeLayout(false);

		}
		#endregion

		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void timer_Tick(object sender, System.EventArgs e)
		{
			pictureBox.Refresh();

			try
			{
				if(listBox.SelectedIndex < 0) return;
				
				txtXPos.Text = ((Punkt)listBox.SelectedItem).Coords.X.ToString();
				txtYPos.Text = ((Punkt)listBox.SelectedItem).Coords.Y.ToString();
				txtXVel.Text = ((Punkt)listBox.SelectedItem).Velocity.X.ToString();
				txtYVel.Text = ((Punkt)listBox.SelectedItem).Velocity.Y.ToString();
			}
			catch {}
		}

		private void cmdAdd_Click(object sender, System.EventArgs e)
		{
			listBox.Items.Add(new Punkt(new Vector(50, 50, 0), new Vector(0,0,0)));

			lbJunction.Items.Add(new Junction((Punkt)listBox.Items[listBox.Items.Count - 1], (Punkt)listBox.Items[0]));

			if(listBox.Items.Count > 1)
			{
				((Junction)lbJunction.Items[listBox.Items.Count - 2]).Endpunkt = (Punkt)listBox.Items[listBox.Items.Count - 1];
			}
		}

		private void frmMain_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if(listBox.SelectedIndex < 0) return;

			switch(e.KeyChar.ToString().ToUpper())
			{
				case "A":
					((Punkt)listBox.SelectedItem).Velocity.X -= 0.1f;
					break;
				case "S":
					((Punkt)listBox.SelectedItem).Velocity.Y += 0.1f;
					break;
				case "D":
					((Punkt)listBox.SelectedItem).Velocity.X += 0.1f;
					break;
				case "W":
					((Punkt)listBox.SelectedItem).Velocity.Y -= 0.1f;
					break;
			}
		}

		private void pictureBox_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			foreach(Punkt punkt in listBox.CheckedItems)
			{
				if(cbGrav.Checked)	punkt.BerechneGrav();
				if(cbLuft.Checked)	punkt.BerechneLuft();
									punkt.BerechnePos(pictureBox.Width, pictureBox.Height);

				e.Graphics.FillRectangle(brushBlack, punkt.Coords.X, punkt.Coords.Y, 2, 2);
			}

			foreach(Junction junction in lbJunction.Items)
			{
				junction.Berechne();
				
				e.Graphics.DrawLine(penBlack, junction.Startpunkt.Coords.X, junction.Startpunkt.Coords.Y, junction.Endpunkt.Coords.X, junction.Endpunkt.Coords.Y);
			}

			if(listBox.SelectedIndex < 0) return;

			try
			{
				if(listBox.GetItemCheckState(listBox.SelectedIndex) == CheckState.Checked)
				{
					Punkt punkti = (Punkt) listBox.SelectedItem;
					e.Graphics.DrawRectangle(penRed, punkti.Coords.X - 3, punkti.Coords.Y - 3, 7, 7);
				}
			}
			catch {}
		}

		private void cmdRemove_Click(object sender, System.EventArgs e)
		{
			if(listBox.SelectedIndex == listBox.Items.Count - 1) // Letzter Punkt in Liste
			{
				((Junction)lbJunction.Items[listBox.SelectedIndex - 1]).Endpunkt = (Punkt)listBox.Items[0];
			}
			else if(listBox.SelectedIndex == 0) // Erster Punkt in Liste
			{
				((Junction)lbJunction.Items[listBox.Items.Count - 1]).Endpunkt = (Punkt)listBox.Items[1];
			}
			else // Ein Punkt in der Mitte
			{
				((Junction)lbJunction.Items[listBox.SelectedIndex - 1]).Endpunkt = (Punkt)listBox.Items[listBox.SelectedIndex + 1];
			}

			lbJunction.Items.Remove(lbJunction.Items[listBox.SelectedIndex]);
			listBox.Items.Remove(listBox.SelectedItem);
		}

		private void pictureBox_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(e.Button == MouseButtons.Left)
			{
				foreach(Punkt punkt in listBox.CheckedItems)
				{
					if(Tools.BerechneEntfernung(e.X, punkt.Coords.X, e.Y, punkt.Coords.Y) < 10)
					{
						listBox.SelectedItem = punkt;
						return;
					}
				}
			}
		}
	}

	public class Tools
	{
		public static double BerechneEntfernung(float x1, float x2, float y1, float y2)
		{
			double a = x1 - x2;
			double b = y1 - y2;

			return Math.Sqrt((a * a) + (b * b));
		}
	}
}